import {createRoute, OpenAPIHono, z} from "@hono/zod-openapi";
import {authMiddleware} from "../../auth/middleware/authMiddleware.js";
import {apiHit} from "../../../globalUtils/apiHits.js";
import {startTCPServer, stopTCPServer} from "../tcpServer.js";

const app = new OpenAPIHono();

const responseSchema = z.object({
    success: z.boolean().openapi({example: true}),
    message: z.string().optional().openapi({example: "user access"}),
});

app.openapi(
    createRoute({
        tags: ["Server:TCP"],
        summary: "Restarts the tcp server up",
        method: "get",
        path: "/",
        middleware: authMiddleware,
        description: "Restarts the tcs server with a delay to allow for the entire system to stop and start back up.",
        responses: {
            200: {
                content: {"application/json": {schema: responseSchema}},
                description: "Succefull restart",
            },
            400: {
                content: {"application/json": {schema: responseSchema}},
                description: "Failed to restart server",
            },
        },
    }),
    async (c) => {
        apiHit(c, {endpoint: "api/tcpServer/restart"});

        try {
            const tcpStopServer = stopTCPServer();
            await new Promise((resolve) => setTimeout(resolve, 5000));
            const tcpServer = startTCPServer();
            //return apiReturn(c, true, access?.message, access?.data, 200);
            return c.json({success: tcpServer.success, message: tcpServer.message}, 200);
        } catch (error) {
            console.log(error);
            //return apiReturn(c, false, "Error in setting the user access", error, 400);
            return c.json({success: false, message: "Error in setting the user access", data: error}, 400);
        }
    }
);
export default app;
